
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>一个php多态性的小例子 / 憋错料</title>

    <meta name="description" content="一个php多态性的小例子 多态性在 OO 中指 &quot;语言具有以不同方式处理不同类型对象的能力&quot;,但 PHP 是弱类型语言,在这一点上就比较弱,仅有 instance of 可以用于判断对象的类型 多态性的优点:让代码更接近生活中的真实情况 一下是一个非常简单的多态性例子,描述在电脑上安装不同操作系统,linux, OS X, windows 和 computer 是两种不同类型的对象. interface os{ function name(); function creator(); } class  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">一个php多态性的小例子</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>多态性在 OO 中指 “语言具有以不同方式处理不同类型对象的能力”，但 PHP 是弱类型语言，在这一点上就比较弱，仅有 instance of 可以用于判断对象的类型</p>
<p>多态性的优点：让代码更接近生活中的真实情况</p>
<p>一下是一个非常简单的多态性例子，描述在电脑上安装不同操作系统，linux, OS X, windows 和 computer 是两种不同类型的对象。</p>
<pre>interface&nbsp;os{

	function&nbsp;name();
	function&nbsp;creator();
}

class&nbsp;linux&nbsp;implements&nbsp;os{

	function&nbsp;name(){
		echo&nbsp;"Linux";
	}
	function&nbsp;creator(){
		echo&nbsp;"&nbsp;(created&nbsp;by&nbsp;Linus&nbsp;Torvalds)";
	}
}

class&nbsp;windows&nbsp;implements&nbsp;os{

	function&nbsp;name(){
		echo&nbsp;"Windows";
	}
	function&nbsp;creator(){
		echo&nbsp;"&nbsp;(created&nbsp;by&nbsp;Microsoft)";
	}
}

class&nbsp;osx&nbsp;implements&nbsp;os{

	function&nbsp;name(){
		echo&nbsp;"OSX";
	}
	function&nbsp;creator(){
		echo&nbsp;"&nbsp;(created&nbsp;by&nbsp;Apple)";
	}
}

class&nbsp;computer{

	function&nbsp;installOS($os){
		if&nbsp;($os&nbsp;instanceof&nbsp;os){
			echo&nbsp;"Installing&nbsp;";
			echo&nbsp;$os-&gt;name();
			echo&nbsp;$os-&gt;creator()."&lt;br&gt;";
	&nbsp;&nbsp;&nbsp;}else{
	&nbsp;&nbsp;&nbsp;		echo&nbsp;"not&nbsp;a&nbsp;system";
	&nbsp;&nbsp;&nbsp;}
	}
}

$myComputer&nbsp;=&nbsp;new&nbsp;computer;

$myLinux&nbsp;=&nbsp;new&nbsp;linux;
$myWindows&nbsp;=&nbsp;new&nbsp;windows;
$myOSX&nbsp;=&nbsp;new&nbsp;osx;

$myComputer-&gt;installOS($myLinux);
$myComputer-&gt;installOS($myWindows);
$myComputer-&gt;installOS($myOSX);</pre>

<p><P><A href="http://www.bubuko.com/infodetail-213866.html" rel="external nofollow noreferrer">一个php多态性的小例子,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 15:39:10 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/php/" title="php">php</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%9a%e6%80%81%e6%80%a7/" title="多态性">多态性</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>一个php多态性的小例子的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MglRvL0.html" rel="bookmark">一个简单的vue小例子之倒计时</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;!DOCTYPE html&gt;&lt;html lang=&quot;en&quot;&gt;&lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;script src=&quot;http://g.tbcdn.cn/mtb/lib-flexible/0.3.4/??flexible_css.js,flexible.js&quot;&gt;&lt;/script&gt; &lt;title&gt;测试&lt;/title&gt; &lt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVbOypM.html" rel="bookmark">一个登陆过滤器的小例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 过滤的路径要有统一的可以表示的路径,以方便模块化过滤 例如:用户模块:/user/*,信息模块:/info/* 2. 过滤器要有能排除不过滤路径的功能: 3. 实现相关的业务需要: import java.io.IOException; import java.util.ArrayList; import java.util.List; import javax.servlet.Filter; import javax.servlet.FilterChain; import javax.s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/352RQE4.html" rel="bookmark">JAVA数据库应用的一个小例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自己随便写的,以炉石为背景,写一个参考用的小例子,先上SQL表: if OBJECT_ID('card_pool') is not null drop table card_pool; create table card_pool( card_id int identity(1,1) not null, card_name varchar(32), card_occupation varchar(32), --卡牌职业:中立.德鲁伊.猎人.法师.圣骑士.牧师.潜伏者.萨满祭司.术士.战士 car			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MykOEm3.html" rel="bookmark">Vue2&period;x源码学习笔记-从一个小例子查看vm实例生命周期</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习任何一门框架,都不可能一股脑儿的从入口代码从上到下,把代码看完, 这样其实是很枯燥的,我想也很少有人这么干,或者这么干着干着可能干不下去了. 因为肯定很无聊. 我们先从一个最最简单的小例子,来查看new Vue(options)实例,这个过程发生了什么. vm实例上的属性又如何添加上去的,又如何渲染到浏览器页面上的. 关于vue的数据依赖和虚拟dom都是重点,必然会在以后的帖子记录. 这篇帖子就根据下例子,看看实例化一个vm实例做了啥吧. 先把小例子贴出来: &lt;div id=&quot;app&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/g41YQO4.html" rel="bookmark">spring小例子-springMVC&plus;mybits整合的小例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这段时间没更博,找房去了...   吐槽一下,自如太坑了...承诺的三年不涨房租,结果今年一看北京房租都在涨也跟着涨了... 而且自如太贵了,租不起了.. 突然有点理解女生找对象要房了..   搬家太受罪了... 今天更一下springMVC整合mybits形成最简单的网站demo. 大概效果就是这样的:左边是数据库查询结果,右边是页面访问结果: 首先,一个简单的springMVC小例子可以看这个http://www.cnblogs.com/xuejupo/p/5236448.html 这是在这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YGrJN4.html" rel="bookmark">java即时通信小例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学习java一段时间了,今天写来一个即时通信的小例子练手在其过程中也学到了一些知识拿出来和大家分享,请路过的各位大神多多赐教... 好了下面讲一下基本的思路: 首先,编写服务器端的程序,简单点说吧就是在服务上开启一个线程循环等待客户端的连接,为每一个连接到服务器的Socket 创建一个实例存放在集合中,然后使用InputSteam读取从客户端发过来的数据然后转发给除自己之外的所有的客户端 然后是客户端,首先开启一个线程连接都服务器端,循环监听服务器发送回来的数据 这里要说一下为了明确是谁发出的消			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xBkez4.html" rel="bookmark">一个基本的傅立叶变换例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				clear;clc; tempresult=[]; figure for i=1:6 filename=['ROISignals_sub_00' num2str(i) '_2000.mat']; data=importdata(filename); x=data(:,1); fs=2; % L=length(x); L=256; y1=fft(x,L); y2=fftshift(y1); mag=abs(y2); f=(0:L-1)*fs/L-fs/2; tempresult=[tempresu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n6BPv0.html" rel="bookmark">vuex在组件化开发中的简单应用小例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先, 介绍一下vuex是个什么东西, 个人理解来说, vuex就是一个状态管理的东西, 它里面有且仅有一个Store仓库, 这个仓库里面存放着一些变量, 为什么要有这么一个变量呢, 用过vue的人肯定都清除, 父子组件之间的通讯传值是个比较麻烦的事情, 特别是, 嵌套组件特别多的时候, 这种情况下, 一级一级地传递下去十分麻烦, 还有就是兄弟组件之间的传值也一样麻烦. 而vuex中的Store这个仓库, 就能够为我们将放在这个仓库中的值, 分发给整个项目下的所有组件, 也就是说是, 不用一级一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r8ZQgM.html" rel="bookmark">gridlayout小例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;!DOCTYPE html&gt;&lt;html lang=&quot;en&quot;&gt;&lt;head&gt;  &lt;meta charset=&quot;UTF-8&quot;&gt;  &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width, initial-scale=1.0&quot;&gt;  &lt;meta http-equiv=&quot;X-UA-Compatible&quot; co			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXkLa4.html" rel="bookmark" class="title">笔记01 登录、常用配置参数、Action访问Servlet API 和设置Action中对象的值、命名空间和乱码处理、Action中包含多个方法如何调用</a>
					<div>
						Struts2登录 1. 需要注意:Struts2需要运行在JRE1.5及以上版本 2. 在web.xml配置文件中,配置StrutsPrepareAndExecuteFilter或FilterDis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEo5mZ3.html" rel="bookmark" class="title">Android Studio四十四期 - 倒计时</a>
					<div>
						现在倒计时有很多种方法,这里给大家两个方法,代码经过洗礼: 1.CountDownTimer:调用的时候很简单:timer.start();    timer.cancel(); private Te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvr6Q0.html" rel="bookmark" class="title">IC卡解密从零开始学2 版本更新&excl; 解密工具PN532-mfoc-mfcuk-GUI V2&period;1  By&colon;lookyour</a>
					<div>
						程序更新 更新内容最下面 2017/5/3 V2.1====================================== 最简要介绍下M1卡数据结构 目前能看到的有2种M1卡,分别为S50 S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXLd73.html" rel="bookmark" class="title">施润行160809301（5）</a>
					<div>
						#include&lt;stdio.h&gt; int main() { int a,b,c,i; printf(&quot;输入三个整数:&quot;); scanf(&quot;%d %d %d& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrZxN4.html" rel="bookmark" class="title">&amp;&num;39&semi;The sandbox is not sync with the Podfile&period;lock&amp;&num;39&semi;问题解决</a>
					<div>
						github下载的Demo,很多时候使用到CocoaPods,有的时候因为依赖关系或者版本问题不能编译运行.出现例如The sandbox is not sync with the Podfile.l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388yN23.html" rel="bookmark" class="title">35 个必须有的Bootstrap工具和生成器</a>
					<div>
						Bootstraptor If you think that bootstrap templates are not enough for you, you should go with bootst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lG8gBM.html" rel="bookmark" class="title">淘宝购物 选择平板</a>
					<div>
						1. 379元 Uniscom/紫光电子 mz85 8GB WIFI 安卓平板电脑8寸四核八显10.6 8寸高清屏1024*768分辨率,完美4:3显示比例,高清四核跑分上万 高清HDMI输出!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4985eJ3.html" rel="bookmark" class="title">推荐算法&mdash;&mdash;非负矩阵分解&lpar;NMF&rpar;</a>
					<div>
						一.矩阵分解回想 在博文推荐算法--基于矩阵分解的推荐算法中,提到了将用户-商品矩阵进行分解.从而实现对未打分项进行打分. 矩阵分解是指将一个矩阵分解成两个或者多个矩阵的乘积.对于上述的用户-商品矩阵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvQNe3.html" rel="bookmark" class="title">yum源安装Mysql</a>
					<div>
						Mysql版本:5.7 进入mysql官网,复制下载链接 步骤: (1) wget  http://dev.mysql.com/get/mysql57-community-release-el6-9. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoawLl3.html" rel="bookmark" class="title">第4章  初始化和清除</a>
					<div>
						4.1 用构建器自动初始化对于方法的创建,可将其想象成为自己写的每个类都调用一次initialize().这个名字提醒我们在使用对象之前,应首先进行这样的调用.但不幸的是,这也意味着用户必须记住调用方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNbrg4.html" rel="bookmark" class="title">Altium Designer 画板流程</a>
					<div>
						以八引脚的AD8009同相放大器为例,回顾Altium Designer画板子的流程,有以下几步: 1.新建工程,并新建sch文件并添加工程.画出板子的原理图(sch): a.大部分的原理图器件都能在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49epXX4.html" rel="bookmark" class="title">【微信小程序】解决 竖向&amp;lt&semi;scroll-view&amp;gt&semi;组件 &OpenCurlyDoubleQuote;竖向滚动页面出现遮挡&rdquo;问题</a>
					<div>
						问题图: 问题原因: &lt;scroll-view class=&quot;scroll-container&quot; upper-threshold=&quot;{{sortPanelDist} ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqVow0.html" rel="bookmark" class="title">每天五个java相关面试题（7）--线程篇</a>
					<div>
						首先关于线程能够先看我之前这篇博文熟悉一下线程生命周期的图示以及文字说明 好開始了: 1.java 中有几种方法能够实现一个线程? 答:有两种实现方法.各自是继承 Thread类与实现Runnable ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLRvqA3.html" rel="bookmark" class="title">UVa12264 Risk（最大流）</a>
					<div>
						题目 Source https://uva.onlinejudge.org/index.php?option=com_onlinejudge&amp;Itemid=8&amp;page=show_pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NyQ283.html" rel="bookmark" class="title">文件的输入输出操作IO</a>
					<div>
						数据流输出到文件流程: 1.新建文件对象:File f = new File(&quot;D:/a.txt&quot;); 2.构建文件输出流对象,如果不存在则新建文件: OutputStream o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qGlPpM.html" rel="bookmark" class="title">Swift Cheat Sheet</a>
					<div>
						swift的一些速查表,转载过来的,但是粘贴代码的时候换行都出问题了,这个该怎么解决? 不喜欢格式的可以看原文:http://codeinswift.com/swift-cheat-sheet/ Ba ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQoPl0.html" rel="bookmark" class="title">input限定文件上传类型：Microsoft Office MIME types</a>
					<div>
						&lt;input id = &quot; &quot; name = &quot; &quot; type = &quot; file &quot; accept=&quot; ? ? ? &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpOYo4.html" rel="bookmark" class="title">&lbrack;Java&rsqb; Java反射</a>
					<div>
						首先推荐三个十分有趣的网站: http://www.programcreek.com/simple-java/ http://tutorials.jenkov.com/ http://www.meet ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qbkXD4.html" rel="bookmark" class="title">N个富文本编辑器&sol;基于Web的HTML编辑器</a>
					<div>
						转自:http://www.cnblogs.com/lingyuan/archive/2010/11/15/1877447.html 基于WEB的HTML 编辑器,WYSIWYG所见即所得的编辑器,或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAkQk0.html" rel="bookmark" class="title">mas 中scrollview碰到的问题。ios10&period;0后</a>
					<div>
						在ios10.0 后 xcode8 后使用masonry碰到一些问题总结如下 1.用mas布局的子控件无法打印frame 网上查资料说是masonry的bug目前未修复.同时因为这个问题,scroll ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
